%global cmapdir %(echo `rpm -qls ghostscript | grep CMap | awk '{print $2}'`)
%global pypi_name reportlab

%bcond_without tests

Summary:        Library for generating PDFs and graphics
Name:           python-%{pypi_name}
Version:        3.6.11
Release:        2%{?dist}
License:        BSD and GPLv2+
URL:            https://www.reportlab.com/opensource/
Source0:        %pypi_source

BuildRequires:  gcc
BuildRequires:  freetype-devel ghostscript libart_lgpl-devel
Buildrequires:  fontpackages-devel font(dejavusans)

%description
This package provides the ReportLab PDF Toolkit, which allows rapid creation of rich PDF 
documents, and also creation of charts in a variety of bitmap and vector formats.

%package -n     python3-%{pypi_name}
Summary:        Library for generating PDFs and graphics
BuildRequires:  python3-devel python3-setuptools python3-pillow
Requires:       font(dejavusans)
Provides:       python-%{pypi_name} = %{version}-%{release}
Provides:       python3-%{pypi_name} = %{version}-%{release}
Provides:       python%{python3_version}-%{pypi_name} = %{version}

%description -n python3-%{pypi_name}
This package provides the ReportLab PDF Toolkit, which allows rapid creation of rich PDF 
documents, and also creation of charts in a variety of bitmap and vector formats.

%prep
%autosetup -n %{pypi_name}-%{version}

find src -name '*.py' | xargs sed -i -e '/^#!\//d'

sed -i '/\~\/\.local\/share\/fonts\/CMap/i''\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ '\'%{cmapdir}\''\,' src/reportlab/rl_settings.py

rm -rf src/reportlab.egg-info
rm -rf src/rl_addons/renderPM/libart_lgpl

%build
CFLAGS="%{build_cflags} -Isrc/rl_addons/renderPM `pkg-config --cflags libart-2.0`" \
 %py3_build -- --use-system-libart --no-download-t1-files

%install
CFLAGS="%{build_cflags} -Isrc/rl_addons/renderPM `pkg-config --cflags libart-2.0`" \
 %py3_install -- --use-system-libart --no-download-t1-files

# unbundled fonts
ln -sf $(fc-match -f "%{file}" "DejaVu Sans:style=Regular") %{buildroot}%{python3_sitearch}/reportlab/fonts/Vera.ttf
ln -sf $(fc-match -f "%{file}" "DejaVu Sans:style=Bold Oblique") %{buildroot}%{python3_sitearch}/reportlab/fonts/VeraBI.ttf
ln -sf $(fc-match -f "%{file}" "DejaVu Sans:style=Bold") %{buildroot}%{python3_sitearch}/reportlab/fonts/VeraBd.ttf
ln -sf $(fc-match -f "%{file}" "DejaVu Sans:style=Condensed Oblique") %{buildroot}%{python3_sitearch}/reportlab/fonts/VeraIt.ttf

rm -f %{buildroot}%{python3_sitearch}/reportlab/fonts/bitstream-vera-license.txt

cp -a demos %{buildroot}%{python3_sitearch}/reportlab/
cp -a tools %{buildroot}%{python3_sitearch}/reportlab/

pathfix.py -pn -i "%{__python3}" %{buildroot}%{python3_sitearch}/reportlab/demos/tests/testdemos.py
pathfix.py -pn -i "%{__python3}" %{buildroot}%{python3_sitearch}/reportlab/tools/docco/docpy.py
pathfix.py -pn -i "%{__python3}" %{buildroot}%{python3_sitearch}/reportlab/tools/docco/graphdocpy.py
pathfix.py -pn -i "%{__python3}" %{buildroot}%{python3_sitearch}/reportlab/tools/docco/rl_doc_utils.py
pathfix.py -pn -i "%{__python3}" %{buildroot}%{python3_sitearch}/reportlab/tools/pythonpoint/pythonpoint.py

chmod 0755 %{buildroot}%{python3_sitearch}/reportlab/demos/tests/testdemos.py
chmod 0755 %{buildroot}%{python3_sitearch}/reportlab/tools/docco/docpy.py
chmod 0755 %{buildroot}%{python3_sitearch}/reportlab/tools/docco/graphdocpy.py
chmod 0755 %{buildroot}%{python3_sitearch}/reportlab/tools/docco/rl_doc_utils.py
chmod 0755 %{buildroot}%{python3_sitearch}/reportlab/tools/pythonpoint/pythonpoint.py

%if %{with tests}
%check
# tests need to execute in-build compiled Python modules, and pre-generate userguide PDF
cp -a build/lib.%{python3_platform}-cpython-%{python3_version_nodots}/reportlab tests/
cp -a build/lib.%{python3_platform}-cpython-%{python3_version_nodots}/reportlab docs/
cp -a build/lib.%{python3_platform}-cpython-%{python3_version_nodots}/reportlab docs/userguide/
%{__python3} setup.py tests
%endif

%files -n python3-%{pypi_name}
%license LICENSE.txt
%doc README.txt CHANGES.md docs/reportlab-userguide.pdf
%{python3_sitearch}/reportlab/
%{python3_sitearch}/reportlab-%{version}-py%{python3_version}.egg-info

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.6.11-2
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Apr 14 2023 Wang Guodong <gordonwwang@tencent.com> - 3.6.11-1
- initial build
